*** a/contrib/pg_upgrade/info.c
--- b/contrib/pg_upgrade/info.c
***************
*** 321,332 **** get_rel_infos(ClusterInfo *cluster, DbInfo *dbinfo)
  							  "INSERT INTO info_rels "
  							  "SELECT reltoastrelid "
  							  "FROM info_rels i JOIN pg_catalog.pg_class c "
! 							  "		ON i.reloid = c.oid"));
  	PQclear(executeQueryOrDie(conn,
  							  "INSERT INTO info_rels "
! 							  "SELECT reltoastidxid "
! 							  "FROM info_rels i JOIN pg_catalog.pg_class c "
! 							  "		ON i.reloid = c.oid"));
  
  	snprintf(query, sizeof(query),
  			 "SELECT c.oid, n.nspname, c.relname, "
--- 321,339 ----
  							  "INSERT INTO info_rels "
  							  "SELECT reltoastrelid "
  							  "FROM info_rels i JOIN pg_catalog.pg_class c "
! 							  "		ON i.reloid = c.oid "
! 							  "		AND c.reltoastrelid != %u", InvalidOid));
  	PQclear(executeQueryOrDie(conn,
  							  "INSERT INTO info_rels "
! 							  "SELECT indexrelid "
! 							  "FROM pg_index "
! 							  "WHERE indisvalid "
! 							  "    AND indrelid IN (SELECT reltoastrelid "
! 							  "        FROM info_rels i "
! 							  "            JOIN pg_catalog.pg_class c "
! 							  "            ON i.reloid = c.oid "
! 							  "            AND c.reltoastrelid != %u)",
! 							  InvalidOid));
  
  	snprintf(query, sizeof(query),
  			 "SELECT c.oid, n.nspname, c.relname, "
*** a/doc/src/sgml/catalogs.sgml
--- b/doc/src/sgml/catalogs.sgml
***************
*** 1745,1759 ****
       </row>
  
       <row>
-       <entry><structfield>reltoastidxid</structfield></entry>
-       <entry><type>oid</type></entry>
-       <entry><literal><link linkend="catalog-pg-class"><structname>pg_class</structname></link>.oid</literal></entry>
-       <entry>
-        For a TOAST table, the OID of its index.  0 if not a TOAST table.
-       </entry>
-      </row>
- 
-      <row>
        <entry><structfield>relhasindex</structfield></entry>
        <entry><type>bool</type></entry>
        <entry></entry>
--- 1745,1750 ----
*** a/doc/src/sgml/diskusage.sgml
--- b/doc/src/sgml/diskusage.sgml
***************
*** 20,31 ****
     stored. If the table has any columns with potentially-wide values,
     there also might be a <acronym>TOAST</> file associated with the table,
     which is used to store values too wide to fit comfortably in the main
!    table (see <xref linkend="storage-toast">).  There will be one index on the
!    <acronym>TOAST</> table, if present. There also might be indexes associated
!    with the base table.  Each table and index is stored in a separate disk
!    file &mdash; possibly more than one file, if the file would exceed one
!    gigabyte.  Naming conventions for these files are described in <xref
!    linkend="storage-file-layout">.
    </para>
  
    <para>
--- 20,31 ----
     stored. If the table has any columns with potentially-wide values,
     there also might be a <acronym>TOAST</> file associated with the table,
     which is used to store values too wide to fit comfortably in the main
!    table (see <xref linkend="storage-toast">).  There will be one valid index
!    on the <acronym>TOAST</> table, if present. There also might be indexes
!    associated with the base table.  Each table and index is stored in a
!    separate disk file &mdash; possibly more than one file, if the file would
!    exceed one gigabyte.  Naming conventions for these files are described
!    in <xref linkend="storage-file-layout">.
    </para>
  
    <para>
***************
*** 44,50 ****
  <programlisting>
  SELECT pg_relation_filepath(oid), relpages FROM pg_class WHERE relname = 'customer';
  
!  pg_relation_filepath | relpages 
  ----------------------+----------
   base/16384/16806     |       60
  (1 row)
--- 44,50 ----
  <programlisting>
  SELECT pg_relation_filepath(oid), relpages FROM pg_class WHERE relname = 'customer';
  
!  pg_relation_filepath | relpages
  ----------------------+----------
   base/16384/16806     |       60
  (1 row)
***************
*** 65,76 **** FROM pg_class,
        FROM pg_class
        WHERE relname = 'customer') AS ss
  WHERE oid = ss.reltoastrelid OR
!       oid = (SELECT reltoastidxid
!              FROM pg_class
!              WHERE oid = ss.reltoastrelid)
  ORDER BY relname;
  
!        relname        | relpages 
  ----------------------+----------
   pg_toast_16806       |        0
   pg_toast_16806_index |        1
--- 65,76 ----
        FROM pg_class
        WHERE relname = 'customer') AS ss
  WHERE oid = ss.reltoastrelid OR
!       oid = (SELECT indexrelid
!              FROM pg_index
!              WHERE indrelid = ss.reltoastrelid)
  ORDER BY relname;
  
!        relname        | relpages
  ----------------------+----------
   pg_toast_16806       |        0
   pg_toast_16806_index |        1
***************
*** 87,93 **** WHERE c.relname = 'customer' AND
        c2.oid = i.indexrelid
  ORDER BY c2.relname;
  
!        relname        | relpages 
  ----------------------+----------
   customer_id_indexdex |       26
  </programlisting>
--- 87,93 ----
        c2.oid = i.indexrelid
  ORDER BY c2.relname;
  
!        relname        | relpages
  ----------------------+----------
   customer_id_indexdex |       26
  </programlisting>
***************
*** 101,107 **** SELECT relname, relpages
  FROM pg_class
  ORDER BY relpages DESC;
  
!        relname        | relpages 
  ----------------------+----------
   bigtable             |     3290
   customer             |     3144
--- 101,107 ----
  FROM pg_class
  ORDER BY relpages DESC;
  
!        relname        | relpages
  ----------------------+----------
   bigtable             |     3290
   customer             |     3144
*** a/doc/src/sgml/monitoring.sgml
--- b/doc/src/sgml/monitoring.sgml
***************
*** 1163,1174 **** postgres: <replaceable>user</> <replaceable>database</> <replaceable>host</> <re
      <row>
       <entry><structfield>tidx_blks_read</></entry>
       <entry><type>bigint</></entry>
!      <entry>Number of disk blocks read from this table's TOAST table index (if any)</entry>
      </row>
      <row>
       <entry><structfield>tidx_blks_hit</></entry>
       <entry><type>bigint</></entry>
!      <entry>Number of buffer hits in this table's TOAST table index (if any)</entry>
      </row>
     </tbody>
     </tgroup>
--- 1163,1174 ----
      <row>
       <entry><structfield>tidx_blks_read</></entry>
       <entry><type>bigint</></entry>
!      <entry>Number of disk blocks read from this table's TOAST table indexes (if any)</entry>
      </row>
      <row>
       <entry><structfield>tidx_blks_hit</></entry>
       <entry><type>bigint</></entry>
!      <entry>Number of buffer hits in this table's TOAST table indexes (if any)</entry>
      </row>
     </tbody>
     </tgroup>
*** a/src/backend/access/heap/tuptoaster.c
--- b/src/backend/access/heap/tuptoaster.c
***************
*** 76,86 **** do { \
  static void toast_delete_datum(Relation rel, Datum value);
  static Datum toast_save_datum(Relation rel, Datum value,
  				 struct varlena * oldexternal, int options);
! static bool toastrel_valueid_exists(Relation toastrel, Oid valueid);
  static bool toastid_valueid_exists(Oid toastrelid, Oid valueid);
  static struct varlena *toast_fetch_datum(struct varlena * attr);
  static struct varlena *toast_fetch_datum_slice(struct varlena * attr,
  						int32 sliceoffset, int32 length);
  
  
  /* ----------
--- 76,88 ----
  static void toast_delete_datum(Relation rel, Datum value);
  static Datum toast_save_datum(Relation rel, Datum value,
  				 struct varlena * oldexternal, int options);
! static bool toastrel_valueid_exists(Relation toastrel,
! 						Oid valueid, LOCKMODE lockmode);
  static bool toastid_valueid_exists(Oid toastrelid, Oid valueid);
  static struct varlena *toast_fetch_datum(struct varlena * attr);
  static struct varlena *toast_fetch_datum_slice(struct varlena * attr,
  						int32 sliceoffset, int32 length);
+ static Relation toast_index_fetch_valid(Relation *toastidxs, int num_indexes);
  
  
  /* ----------
***************
*** 1222,1227 **** toast_compress_datum(Datum value)
--- 1224,1272 ----
  
  
  /* ----------
+  * toast_get_valid_index
+  *
+  *	Get the valid index of given toast relation. A toast relation can only
+  *	have one valid index at the same time. The lock taken on the index
+  *	relations is released at the end of this function call.
+  */
+ Oid
+ toast_get_valid_index(Oid toastoid, LOCKMODE lock)
+ {
+ 	ListCell   *lc;
+ 	List	   *indexlist;
+ 	int			num_indexes, i = 0;
+ 	Oid			validIndexOid;
+ 	Relation	validIndexRel;
+ 	Relation   *toastidxs;
+ 	Relation	toastrel;
+ 
+ 	/* Get the index list of relation */
+ 	toastrel = heap_open(toastoid, lock);
+ 	indexlist = RelationGetIndexList(toastrel);
+ 	num_indexes = list_length(indexlist);
+ 
+ 	/* Open all the index relations */
+ 	toastidxs = (Relation *) palloc(num_indexes * sizeof(Relation));
+ 	foreach(lc, indexlist)
+ 		toastidxs[i++] = index_open(lfirst_oid(lc), lock);
+ 
+ 	/* Fetch valid toast index */
+ 	validIndexRel = toast_index_fetch_valid(toastidxs, num_indexes);
+ 	validIndexOid = RelationGetRelid(validIndexRel);
+ 
+ 	/* Close all the index relations */
+ 	for (i = 0; i < num_indexes; i++)
+ 		index_close(toastidxs[i], lock);
+ 	pfree(toastidxs);
+ 	list_free(indexlist);
+ 
+ 	heap_close(toastrel, lock);
+ 	return validIndexOid;
+ }
+ 
+ 
+ /* ----------
   * toast_save_datum -
   *
   *	Save one single datum into the secondary relation and return
***************
*** 1237,1244 **** static Datum
  toast_save_datum(Relation rel, Datum value,
  				 struct varlena * oldexternal, int options)
  {
! 	Relation	toastrel;
! 	Relation	toastidx;
  	HeapTuple	toasttup;
  	TupleDesc	toasttupDesc;
  	Datum		t_values[3];
--- 1282,1289 ----
  toast_save_datum(Relation rel, Datum value,
  				 struct varlena * oldexternal, int options)
  {
! 	Relation	toastrel, validtoastidx;
! 	Relation   *toastidxs;
  	HeapTuple	toasttup;
  	TupleDesc	toasttupDesc;
  	Datum		t_values[3];
***************
*** 1257,1271 **** toast_save_datum(Relation rel, Datum value,
  	char	   *data_p;
  	int32		data_todo;
  	Pointer		dval = DatumGetPointer(value);
  
  	/*
  	 * Open the toast relation and its index.  We can use the index to check
  	 * uniqueness of the OID we assign to the toasted item, even though it has
! 	 * additional columns besides OID.
  	 */
  	toastrel = heap_open(rel->rd_rel->reltoastrelid, RowExclusiveLock);
  	toasttupDesc = toastrel->rd_att;
! 	toastidx = index_open(toastrel->rd_rel->reltoastidxid, RowExclusiveLock);
  
  	/*
  	 * Get the data pointer and length, and compute va_rawsize and va_extsize.
--- 1302,1331 ----
  	char	   *data_p;
  	int32		data_todo;
  	Pointer		dval = DatumGetPointer(value);
+ 	ListCell   *lc;
+ 	List	   *indexlist;
+ 	int			i = 0;
+ 	int			num_indexes;
  
  	/*
  	 * Open the toast relation and its index.  We can use the index to check
  	 * uniqueness of the OID we assign to the toasted item, even though it has
! 	 * additional columns besides OID. A toast table can have multiple identical
! 	 * indexes associated to it.
  	 */
  	toastrel = heap_open(rel->rd_rel->reltoastrelid, RowExclusiveLock);
  	toasttupDesc = toastrel->rd_att;
! 	indexlist = RelationGetIndexList(toastrel);
! 	num_indexes = list_length(indexlist);
! 
! 	toastidxs = (Relation *) palloc(num_indexes * sizeof(Relation));
! 
! 	/* Open all the indexes of toast relation with similar lock */
! 	foreach(lc, indexlist)
! 		toastidxs[i++] = index_open(lfirst_oid(lc), RowExclusiveLock);
! 
! 	/* Fetch relation used for process */
! 	validtoastidx = toast_index_fetch_valid(toastidxs, num_indexes);
  
  	/*
  	 * Get the data pointer and length, and compute va_rawsize and va_extsize.
***************
*** 1330,1336 **** toast_save_datum(Relation rel, Datum value,
  		/* normal case: just choose an unused OID */
  		toast_pointer.va_valueid =
  			GetNewOidWithIndex(toastrel,
! 							   RelationGetRelid(toastidx),
  							   (AttrNumber) 1);
  	}
  	else
--- 1390,1396 ----
  		/* normal case: just choose an unused OID */
  		toast_pointer.va_valueid =
  			GetNewOidWithIndex(toastrel,
! 							   RelationGetRelid(validtoastidx),
  							   (AttrNumber) 1);
  	}
  	else
***************
*** 1367,1373 **** toast_save_datum(Relation rel, Datum value,
  				 * be reclaimed by VACUUM.
  				 */
  				if (toastrel_valueid_exists(toastrel,
! 											toast_pointer.va_valueid))
  				{
  					/* Match, so short-circuit the data storage loop below */
  					data_todo = 0;
--- 1427,1434 ----
  				 * be reclaimed by VACUUM.
  				 */
  				if (toastrel_valueid_exists(toastrel,
! 											toast_pointer.va_valueid,
! 											RowExclusiveLock))
  				{
  					/* Match, so short-circuit the data storage loop below */
  					data_todo = 0;
***************
*** 1384,1390 **** toast_save_datum(Relation rel, Datum value,
  			{
  				toast_pointer.va_valueid =
  					GetNewOidWithIndex(toastrel,
! 									   RelationGetRelid(toastidx),
  									   (AttrNumber) 1);
  			} while (toastid_valueid_exists(rel->rd_toastoid,
  											toast_pointer.va_valueid));
--- 1445,1451 ----
  			{
  				toast_pointer.va_valueid =
  					GetNewOidWithIndex(toastrel,
! 									   RelationGetRelid(validtoastidx),
  									   (AttrNumber) 1);
  			} while (toastid_valueid_exists(rel->rd_toastoid,
  											toast_pointer.va_valueid));
***************
*** 1423,1438 **** toast_save_datum(Relation rel, Datum value,
  		/*
  		 * Create the index entry.	We cheat a little here by not using
  		 * FormIndexDatum: this relies on the knowledge that the index columns
! 		 * are the same as the initial columns of the table.
  		 *
  		 * Note also that there had better not be any user-created index on
  		 * the TOAST table, since we don't bother to update anything else.
  		 */
! 		index_insert(toastidx, t_values, t_isnull,
! 					 &(toasttup->t_self),
! 					 toastrel,
! 					 toastidx->rd_index->indisunique ?
! 					 UNIQUE_CHECK_YES : UNIQUE_CHECK_NO);
  
  		/*
  		 * Free memory
--- 1484,1501 ----
  		/*
  		 * Create the index entry.	We cheat a little here by not using
  		 * FormIndexDatum: this relies on the knowledge that the index columns
! 		 * are the same as the initial columns of the table for all the
! 		 * indexes.
  		 *
  		 * Note also that there had better not be any user-created index on
  		 * the TOAST table, since we don't bother to update anything else.
  		 */
! 		for (i = 0; i < num_indexes; i++)
! 			index_insert(toastidxs[i], t_values, t_isnull,
! 						 &(toasttup->t_self),
! 						 toastrel,
! 						 toastidxs[i]->rd_index->indisunique ?
! 						 UNIQUE_CHECK_YES : UNIQUE_CHECK_NO);
  
  		/*
  		 * Free memory
***************
*** 1447,1456 **** toast_save_datum(Relation rel, Datum value,
  	}
  
  	/*
! 	 * Done - close toast relation
  	 */
! 	index_close(toastidx, RowExclusiveLock);
  	heap_close(toastrel, RowExclusiveLock);
  
  	/*
  	 * Create the TOAST pointer value that we'll return
--- 1510,1522 ----
  	}
  
  	/*
! 	 * Done - close toast relations
  	 */
! 	for (i = 0; i < num_indexes; i++)
! 		index_close(toastidxs[i], RowExclusiveLock);
! 	list_free(indexlist);
  	heap_close(toastrel, RowExclusiveLock);
+ 	pfree(toastidxs);
  
  	/*
  	 * Create the TOAST pointer value that we'll return
***************
*** 1474,1484 **** toast_delete_datum(Relation rel, Datum value)
  {
  	struct varlena *attr = (struct varlena *) DatumGetPointer(value);
  	struct varatt_external toast_pointer;
! 	Relation	toastrel;
! 	Relation	toastidx;
  	ScanKeyData toastkey;
  	SysScanDesc toastscan;
  	HeapTuple	toasttup;
  
  	if (!VARATT_IS_EXTERNAL(attr))
  		return;
--- 1540,1554 ----
  {
  	struct varlena *attr = (struct varlena *) DatumGetPointer(value);
  	struct varatt_external toast_pointer;
! 	Relation	toastrel, validtoastidx;
! 	Relation   *toastidxs;
  	ScanKeyData toastkey;
  	SysScanDesc toastscan;
  	HeapTuple	toasttup;
+ 	ListCell   *lc;
+ 	List	   *indexlist;
+ 	int			num_indexes;
+ 	int			i = 0;
  
  	if (!VARATT_IS_EXTERNAL(attr))
  		return;
***************
*** 1487,1496 **** toast_delete_datum(Relation rel, Datum value)
  	VARATT_EXTERNAL_GET_POINTER(toast_pointer, attr);
  
  	/*
! 	 * Open the toast relation and its index
  	 */
  	toastrel = heap_open(toast_pointer.va_toastrelid, RowExclusiveLock);
! 	toastidx = index_open(toastrel->rd_rel->reltoastidxid, RowExclusiveLock);
  
  	/*
  	 * Setup a scan key to find chunks with matching va_valueid
--- 1557,1578 ----
  	VARATT_EXTERNAL_GET_POINTER(toast_pointer, attr);
  
  	/*
! 	 * Open the toast relation and its indexes
  	 */
  	toastrel = heap_open(toast_pointer.va_toastrelid, RowExclusiveLock);
! 	indexlist = RelationGetIndexList(toastrel);
! 	num_indexes = list_length(indexlist);
! 	toastidxs = (Relation *) palloc(num_indexes * sizeof(Relation));
! 
! 	/*
! 	 * We actually use only the first valid index but taking a lock on all is
! 	 * necessary.
! 	 */
! 	foreach(lc, indexlist)
! 		toastidxs[i++] = index_open(lfirst_oid(lc), RowExclusiveLock);
! 
! 	/* Fetch relation used for process */
! 	validtoastidx = toast_index_fetch_valid(toastidxs, num_indexes);
  
  	/*
  	 * Setup a scan key to find chunks with matching va_valueid
***************
*** 1505,1511 **** toast_delete_datum(Relation rel, Datum value)
  	 * sequence or not, but since we've already locked the index we might as
  	 * well use systable_beginscan_ordered.)
  	 */
! 	toastscan = systable_beginscan_ordered(toastrel, toastidx,
  										   SnapshotToast, 1, &toastkey);
  	while ((toasttup = systable_getnext_ordered(toastscan, ForwardScanDirection)) != NULL)
  	{
--- 1587,1593 ----
  	 * sequence or not, but since we've already locked the index we might as
  	 * well use systable_beginscan_ordered.)
  	 */
! 	toastscan = systable_beginscan_ordered(toastrel, validtoastidx,
  										   SnapshotToast, 1, &toastkey);
  	while ((toasttup = systable_getnext_ordered(toastscan, ForwardScanDirection)) != NULL)
  	{
***************
*** 1519,1526 **** toast_delete_datum(Relation rel, Datum value)
  	 * End scan and close relations
  	 */
  	systable_endscan_ordered(toastscan);
! 	index_close(toastidx, RowExclusiveLock);
  	heap_close(toastrel, RowExclusiveLock);
  }
  
  
--- 1601,1611 ----
  	 * End scan and close relations
  	 */
  	systable_endscan_ordered(toastscan);
! 	for (i = 0; i < num_indexes; i++)
! 		index_close(toastidxs[i], RowExclusiveLock);
! 	list_free(indexlist);
  	heap_close(toastrel, RowExclusiveLock);
+ 	pfree(toastidxs);
  }
  
  
***************
*** 1531,1541 **** toast_delete_datum(Relation rel, Datum value)
   * ----------
   */
  static bool
! toastrel_valueid_exists(Relation toastrel, Oid valueid)
  {
  	bool		result = false;
  	ScanKeyData toastkey;
  	SysScanDesc toastscan;
  
  	/*
  	 * Setup a scan key to find chunks with matching va_valueid
--- 1616,1644 ----
   * ----------
   */
  static bool
! toastrel_valueid_exists(Relation toastrel, Oid valueid, LOCKMODE lockmode)
  {
  	bool		result = false;
  	ScanKeyData toastkey;
  	SysScanDesc toastscan;
+ 	int			i = 0;
+ 	int			num_indexes;
+ 	Relation   *toastidxs;
+ 	Relation	validtoastidx;
+ 	ListCell   *lc;
+ 	List	   *indexlist;
+ 
+ 	/* Ensure that the list of indexes of toast relation is computed */
+ 	indexlist = RelationGetIndexList(toastrel);
+ 	num_indexes = list_length(indexlist);
+ 
+ 	/* Open each index relation necessary */
+ 	toastidxs = (Relation *) palloc(num_indexes * sizeof(Relation));
+ 	foreach(lc, indexlist)
+ 		toastidxs[i++] = index_open(lfirst_oid(lc), lockmode);
+ 
+ 	/* Fetch a valid index relation */
+ 	validtoastidx = toast_index_fetch_valid(toastidxs, num_indexes);
  
  	/*
  	 * Setup a scan key to find chunks with matching va_valueid
***************
*** 1548,1554 **** toastrel_valueid_exists(Relation toastrel, Oid valueid)
  	/*
  	 * Is there any such chunk?
  	 */
! 	toastscan = systable_beginscan(toastrel, toastrel->rd_rel->reltoastidxid,
  								   true, SnapshotToast, 1, &toastkey);
  
  	if (systable_getnext(toastscan) != NULL)
--- 1651,1658 ----
  	/*
  	 * Is there any such chunk?
  	 */
! 	toastscan = systable_beginscan(toastrel,
! 								   RelationGetRelid(validtoastidx),
  								   true, SnapshotToast, 1, &toastkey);
  
  	if (systable_getnext(toastscan) != NULL)
***************
*** 1556,1561 **** toastrel_valueid_exists(Relation toastrel, Oid valueid)
--- 1660,1671 ----
  
  	systable_endscan(toastscan);
  
+ 	/* Clean up */
+ 	for (i = 0; i < num_indexes; i++)
+ 		index_close(toastidxs[i], lockmode);
+ 	list_free(indexlist);
+ 	pfree(toastidxs);
+ 
  	return result;
  }
  
***************
*** 1573,1579 **** toastid_valueid_exists(Oid toastrelid, Oid valueid)
  
  	toastrel = heap_open(toastrelid, AccessShareLock);
  
! 	result = toastrel_valueid_exists(toastrel, valueid);
  
  	heap_close(toastrel, AccessShareLock);
  
--- 1683,1689 ----
  
  	toastrel = heap_open(toastrelid, AccessShareLock);
  
! 	result = toastrel_valueid_exists(toastrel, valueid, AccessShareLock);
  
  	heap_close(toastrel, AccessShareLock);
  
***************
*** 1591,1598 **** toastid_valueid_exists(Oid toastrelid, Oid valueid)
  static struct varlena *
  toast_fetch_datum(struct varlena * attr)
  {
! 	Relation	toastrel;
! 	Relation	toastidx;
  	ScanKeyData toastkey;
  	SysScanDesc toastscan;
  	HeapTuple	ttup;
--- 1701,1708 ----
  static struct varlena *
  toast_fetch_datum(struct varlena * attr)
  {
! 	Relation	toastrel, validtoastidx;
! 	Relation   *toastidxs;
  	ScanKeyData toastkey;
  	SysScanDesc toastscan;
  	HeapTuple	ttup;
***************
*** 1607,1612 **** toast_fetch_datum(struct varlena * attr)
--- 1717,1726 ----
  	bool		isnull;
  	char	   *chunkdata;
  	int32		chunksize;
+ 	ListCell   *lc;
+ 	List	   *indexlist;
+ 	int			num_indexes;
+ 	int			i = 0;
  
  	/* Must copy to access aligned fields */
  	VARATT_EXTERNAL_GET_POINTER(toast_pointer, attr);
***************
*** 1622,1632 **** toast_fetch_datum(struct varlena * attr)
  		SET_VARSIZE(result, ressize + VARHDRSZ);
  
  	/*
! 	 * Open the toast relation and its index
  	 */
  	toastrel = heap_open(toast_pointer.va_toastrelid, AccessShareLock);
  	toasttupDesc = toastrel->rd_att;
! 	toastidx = index_open(toastrel->rd_rel->reltoastidxid, AccessShareLock);
  
  	/*
  	 * Setup a scan key to fetch from the index by va_valueid
--- 1736,1756 ----
  		SET_VARSIZE(result, ressize + VARHDRSZ);
  
  	/*
! 	 * Open the toast relation and its indexes
  	 */
  	toastrel = heap_open(toast_pointer.va_toastrelid, AccessShareLock);
  	toasttupDesc = toastrel->rd_att;
! 	indexlist = RelationGetIndexList(toastrel);
! 	num_indexes = list_length(indexlist);
! 
! 	toastidxs = (Relation *) palloc(num_indexes * sizeof(Relation));
! 
! 	/* Open all the indexes of toast relation with similar lock */
! 	foreach(lc, indexlist)
! 		toastidxs[i++] = index_open(lfirst_oid(lc), AccessShareLock);
! 
! 	/* Fetch relation used for process */
! 	validtoastidx = toast_index_fetch_valid(toastidxs, num_indexes);
  
  	/*
  	 * Setup a scan key to fetch from the index by va_valueid
***************
*** 1645,1651 **** toast_fetch_datum(struct varlena * attr)
  	 */
  	nextidx = 0;
  
! 	toastscan = systable_beginscan_ordered(toastrel, toastidx,
  										   SnapshotToast, 1, &toastkey);
  	while ((ttup = systable_getnext_ordered(toastscan, ForwardScanDirection)) != NULL)
  	{
--- 1769,1775 ----
  	 */
  	nextidx = 0;
  
! 	toastscan = systable_beginscan_ordered(toastrel, validtoastidx,
  										   SnapshotToast, 1, &toastkey);
  	while ((ttup = systable_getnext_ordered(toastscan, ForwardScanDirection)) != NULL)
  	{
***************
*** 1734,1741 **** toast_fetch_datum(struct varlena * attr)
  	 * End scan and close relations
  	 */
  	systable_endscan_ordered(toastscan);
! 	index_close(toastidx, AccessShareLock);
  	heap_close(toastrel, AccessShareLock);
  
  	return result;
  }
--- 1858,1868 ----
  	 * End scan and close relations
  	 */
  	systable_endscan_ordered(toastscan);
! 	for (i = 0; i < num_indexes; i++)
! 		index_close(toastidxs[i], AccessShareLock);
! 	list_free(indexlist);
  	heap_close(toastrel, AccessShareLock);
+ 	pfree(toastidxs);
  
  	return result;
  }
***************
*** 1750,1757 **** toast_fetch_datum(struct varlena * attr)
  static struct varlena *
  toast_fetch_datum_slice(struct varlena * attr, int32 sliceoffset, int32 length)
  {
! 	Relation	toastrel;
! 	Relation	toastidx;
  	ScanKeyData toastkey[3];
  	int			nscankeys;
  	SysScanDesc toastscan;
--- 1877,1884 ----
  static struct varlena *
  toast_fetch_datum_slice(struct varlena * attr, int32 sliceoffset, int32 length)
  {
! 	Relation	toastrel, validtoastidx;
! 	Relation   *toastidxs;
  	ScanKeyData toastkey[3];
  	int			nscankeys;
  	SysScanDesc toastscan;
***************
*** 1774,1779 **** toast_fetch_datum_slice(struct varlena * attr, int32 sliceoffset, int32 length)
--- 1901,1910 ----
  	int32		chunksize;
  	int32		chcpystrt;
  	int32		chcpyend;
+ 	int			num_indexes;
+ 	int			i = 0;
+ 	ListCell   *lc;
+ 	List	   *indexlist;
  
  	Assert(VARATT_IS_EXTERNAL(attr));
  
***************
*** 1816,1826 **** toast_fetch_datum_slice(struct varlena * attr, int32 sliceoffset, int32 length)
  	endoffset = (sliceoffset + length - 1) % TOAST_MAX_CHUNK_SIZE;
  
  	/*
! 	 * Open the toast relation and its index
  	 */
  	toastrel = heap_open(toast_pointer.va_toastrelid, AccessShareLock);
  	toasttupDesc = toastrel->rd_att;
! 	toastidx = index_open(toastrel->rd_rel->reltoastidxid, AccessShareLock);
  
  	/*
  	 * Setup a scan key to fetch from the index. This is either two keys or
--- 1947,1964 ----
  	endoffset = (sliceoffset + length - 1) % TOAST_MAX_CHUNK_SIZE;
  
  	/*
! 	 * Open the toast relation and its indexes
  	 */
  	toastrel = heap_open(toast_pointer.va_toastrelid, AccessShareLock);
  	toasttupDesc = toastrel->rd_att;
! 	indexlist = RelationGetIndexList(toastrel);
! 	num_indexes = list_length(indexlist);
! 
! 	toastidxs = (Relation *) palloc(num_indexes * sizeof(Relation));
! 
! 	foreach(lc, indexlist)
! 		toastidxs[i++] = index_open(lfirst_oid(lc), AccessShareLock);
! 	validtoastidx = toast_index_fetch_valid(toastidxs, num_indexes);
  
  	/*
  	 * Setup a scan key to fetch from the index. This is either two keys or
***************
*** 1861,1867 **** toast_fetch_datum_slice(struct varlena * attr, int32 sliceoffset, int32 length)
  	 * The index is on (valueid, chunkidx) so they will come in order
  	 */
  	nextidx = startchunk;
! 	toastscan = systable_beginscan_ordered(toastrel, toastidx,
  										 SnapshotToast, nscankeys, toastkey);
  	while ((ttup = systable_getnext_ordered(toastscan, ForwardScanDirection)) != NULL)
  	{
--- 1999,2005 ----
  	 * The index is on (valueid, chunkidx) so they will come in order
  	 */
  	nextidx = startchunk;
! 	toastscan = systable_beginscan_ordered(toastrel, validtoastidx,
  										 SnapshotToast, nscankeys, toastkey);
  	while ((ttup = systable_getnext_ordered(toastscan, ForwardScanDirection)) != NULL)
  	{
***************
*** 1958,1965 **** toast_fetch_datum_slice(struct varlena * attr, int32 sliceoffset, int32 length)
  	 * End scan and close relations
  	 */
  	systable_endscan_ordered(toastscan);
! 	index_close(toastidx, AccessShareLock);
  	heap_close(toastrel, AccessShareLock);
  
  	return result;
  }
--- 2096,2132 ----
  	 * End scan and close relations
  	 */
  	systable_endscan_ordered(toastscan);
! 	for (i = 0; i < num_indexes; i++)
! 		index_close(toastidxs[i], AccessShareLock);
! 	list_free(indexlist);
  	heap_close(toastrel, AccessShareLock);
+ 	pfree(toastidxs);
  
  	return result;
  }
+ 
+ /* ----------
+  * toast_index_fetch_valid
+  *
+  *	Get a valid index in list of indexes for a toast relation. Those relations
+  *	need to be already open prior calling this routine.
+  */
+ static Relation
+ toast_index_fetch_valid(Relation *toastidxs, int num_indexes)
+ {
+ 	int			i;
+ 	Relation	res = NULL;
+ 
+ 	/* Fetch the first valid index in list */
+ 	for (i = 0; i < num_indexes; i++)
+ 	{
+ 		if (toastidxs[i]->rd_index->indisvalid)
+ 		{
+ 			res = toastidxs[i];
+ 			break;
+ 		}
+ 	}
+ 
+ 	Assert(res);
+ 	return res;
+ }
*** a/src/backend/catalog/heap.c
--- b/src/backend/catalog/heap.c
***************
*** 781,787 **** InsertPgClassTuple(Relation pg_class_desc,
  	values[Anum_pg_class_reltuples - 1] = Float4GetDatum(rd_rel->reltuples);
  	values[Anum_pg_class_relallvisible - 1] = Int32GetDatum(rd_rel->relallvisible);
  	values[Anum_pg_class_reltoastrelid - 1] = ObjectIdGetDatum(rd_rel->reltoastrelid);
- 	values[Anum_pg_class_reltoastidxid - 1] = ObjectIdGetDatum(rd_rel->reltoastidxid);
  	values[Anum_pg_class_relhasindex - 1] = BoolGetDatum(rd_rel->relhasindex);
  	values[Anum_pg_class_relisshared - 1] = BoolGetDatum(rd_rel->relisshared);
  	values[Anum_pg_class_relpersistence - 1] = CharGetDatum(rd_rel->relpersistence);
--- 781,786 ----
*** a/src/backend/catalog/index.c
--- b/src/backend/catalog/index.c
***************
*** 103,109 **** static void UpdateIndexRelation(Oid indexoid, Oid heapoid,
  					bool isvalid);
  static void index_update_stats(Relation rel,
  				   bool hasindex, bool isprimary,
! 				   Oid reltoastidxid, double reltuples);
  static void IndexCheckExclusion(Relation heapRelation,
  					Relation indexRelation,
  					IndexInfo *indexInfo);
--- 103,109 ----
  					bool isvalid);
  static void index_update_stats(Relation rel,
  				   bool hasindex, bool isprimary,
! 				   double reltuples);
  static void IndexCheckExclusion(Relation heapRelation,
  					Relation indexRelation,
  					IndexInfo *indexInfo);
***************
*** 1072,1078 **** index_create(Relation heapRelation,
  		index_update_stats(heapRelation,
  						   true,
  						   isprimary,
- 						   InvalidOid,
  						   -1.0);
  		/* Make the above update visible */
  		CommandCounterIncrement();
--- 1072,1077 ----
*** a/src/backend/catalog/system_views.sql
--- b/src/backend/catalog/system_views.sql
***************
*** 473,488 **** CREATE VIEW pg_statio_all_tables AS
              pg_stat_get_blocks_fetched(T.oid) -
                      pg_stat_get_blocks_hit(T.oid) AS toast_blks_read,
              pg_stat_get_blocks_hit(T.oid) AS toast_blks_hit,
!             pg_stat_get_blocks_fetched(X.oid) -
!                     pg_stat_get_blocks_hit(X.oid) AS tidx_blks_read,
!             pg_stat_get_blocks_hit(X.oid) AS tidx_blks_hit
      FROM pg_class C LEFT JOIN
              pg_index I ON C.oid = I.indrelid LEFT JOIN
              pg_class T ON C.reltoastrelid = T.oid LEFT JOIN
!             pg_class X ON T.reltoastidxid = X.oid
              LEFT JOIN pg_namespace N ON (N.oid = C.relnamespace)
      WHERE C.relkind IN ('r', 't', 'm')
!     GROUP BY C.oid, N.nspname, C.relname, T.oid, X.oid;
  
  CREATE VIEW pg_statio_sys_tables AS
      SELECT * FROM pg_statio_all_tables
--- 473,488 ----
              pg_stat_get_blocks_fetched(T.oid) -
                      pg_stat_get_blocks_hit(T.oid) AS toast_blks_read,
              pg_stat_get_blocks_hit(T.oid) AS toast_blks_hit,
!             sum(pg_stat_get_blocks_fetched(X.indexrelid) -
!                     pg_stat_get_blocks_hit(X.indexrelid))::bigint AS tidx_blks_read,
!             sum(pg_stat_get_blocks_hit(X.indexrelid))::bigint AS tidx_blks_hit
      FROM pg_class C LEFT JOIN
              pg_index I ON C.oid = I.indrelid LEFT JOIN
              pg_class T ON C.reltoastrelid = T.oid LEFT JOIN
!             pg_index X ON T.oid = X.indrelid
              LEFT JOIN pg_namespace N ON (N.oid = C.relnamespace)
      WHERE C.relkind IN ('r', 't', 'm')
!     GROUP BY C.oid, N.nspname, C.relname, T.oid, X.indexrelid;
  
  CREATE VIEW pg_statio_sys_tables AS
      SELECT * FROM pg_statio_all_tables
*** a/src/backend/commands/cluster.c
--- b/src/backend/commands/cluster.c
***************
*** 21,26 ****
--- 21,27 ----
  #include "access/relscan.h"
  #include "access/rewriteheap.h"
  #include "access/transam.h"
+ #include "access/tuptoaster.h"
  #include "access/xact.h"
  #include "catalog/catalog.h"
  #include "catalog/dependency.h"
***************
*** 1172,1179 **** swap_relation_files(Oid r1, Oid r2, bool target_is_pg_class,
  			swaptemp = relform1->reltoastrelid;
  			relform1->reltoastrelid = relform2->reltoastrelid;
  			relform2->reltoastrelid = swaptemp;
- 
- 			/* we should NOT swap reltoastidxid */
  		}
  	}
  	else
--- 1173,1178 ----
*** a/src/backend/commands/tablecmds.c
--- b/src/backend/commands/tablecmds.c
***************
*** 8728,8734 **** ATExecSetTableSpace(Oid tableOid, Oid newTableSpace, LOCKMODE lockmode)
  	Relation	rel;
  	Oid			oldTableSpace;
  	Oid			reltoastrelid;
- 	Oid			reltoastidxid;
  	Oid			newrelfilenode;
  	RelFileNode newrnode;
  	SMgrRelation dstrel;
--- 8728,8733 ----
*** a/src/backend/rewrite/rewriteDefine.c
--- b/src/backend/rewrite/rewriteDefine.c
***************
*** 575,582 **** DefineQueryRewrite(char *rulename,
  
  		/*
  		 * Fix pg_class entry to look like a normal view's, including setting
! 		 * the correct relkind and removal of reltoastrelid/reltoastidxid of
! 		 * the toast table we potentially removed above.
  		 */
  		classTup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(event_relid));
  		if (!HeapTupleIsValid(classTup))
--- 575,582 ----
  
  		/*
  		 * Fix pg_class entry to look like a normal view's, including setting
! 		 * the correct relkind and removal of reltoastrelid of the toast table
! 		 * we potentially removed above.
  		 */
  		classTup = SearchSysCacheCopy1(RELOID, ObjectIdGetDatum(event_relid));
  		if (!HeapTupleIsValid(classTup))
***************
*** 588,594 **** DefineQueryRewrite(char *rulename,
  		classForm->reltuples = 0;
  		classForm->relallvisible = 0;
  		classForm->reltoastrelid = InvalidOid;
- 		classForm->reltoastidxid = InvalidOid;
  		classForm->relhasindex = false;
  		classForm->relkind = RELKIND_VIEW;
  		classForm->relhasoids = false;
--- 588,593 ----
*** a/src/backend/utils/adt/dbsize.c
--- b/src/backend/utils/adt/dbsize.c
***************
*** 332,338 **** pg_relation_size(PG_FUNCTION_ARGS)
  }
  
  /*
!  * Calculate total on-disk size of a TOAST relation, including its index.
   * Must not be applied to non-TOAST relations.
   */
  static int64
--- 332,338 ----
  }
  
  /*
!  * Calculate total on-disk size of a TOAST relation, including its indexes.
   * Must not be applied to non-TOAST relations.
   */
  static int64
***************
*** 340,347 **** calculate_toast_table_size(Oid toastrelid)
  {
  	int64		size = 0;
  	Relation	toastRel;
- 	Relation	toastIdxRel;
  	ForkNumber	forkNum;
  
  	toastRel = relation_open(toastrelid, AccessShareLock);
  
--- 340,348 ----
  {
  	int64		size = 0;
  	Relation	toastRel;
  	ForkNumber	forkNum;
+ 	ListCell   *lc;
+ 	List	   *indexlist;
  
  	toastRel = relation_open(toastrelid, AccessShareLock);
  
***************
*** 351,362 **** calculate_toast_table_size(Oid toastrelid)
  										toastRel->rd_backend, forkNum);
  
  	/* toast index size, including FSM and VM size */
! 	toastIdxRel = relation_open(toastRel->rd_rel->reltoastidxid, AccessShareLock);
! 	for (forkNum = 0; forkNum <= MAX_FORKNUM; forkNum++)
! 		size += calculate_relation_size(&(toastIdxRel->rd_node),
! 										toastIdxRel->rd_backend, forkNum);
  
! 	relation_close(toastIdxRel, AccessShareLock);
  	relation_close(toastRel, AccessShareLock);
  
  	return size;
--- 352,372 ----
  										toastRel->rd_backend, forkNum);
  
  	/* toast index size, including FSM and VM size */
! 	indexlist = RelationGetIndexList(toastRel);
  
! 	/* Size is calculated using all the indexes available */
! 	foreach(lc, indexlist)
! 	{
! 		Relation	toastIdxRel;
! 		toastIdxRel = relation_open(lfirst_oid(lc),
! 									AccessShareLock);
! 		for (forkNum = 0; forkNum <= MAX_FORKNUM; forkNum++)
! 			size += calculate_relation_size(&(toastIdxRel->rd_node),
! 											toastIdxRel->rd_backend, forkNum);
! 
! 		relation_close(toastIdxRel, AccessShareLock);
! 	}
! 	list_free(indexlist);
  	relation_close(toastRel, AccessShareLock);
  
  	return size;
*** a/src/bin/pg_dump/pg_dump.c
--- b/src/bin/pg_dump/pg_dump.c
***************
*** 2781,2796 **** binary_upgrade_set_pg_class_oids(Archive *fout,
  	Oid			pg_class_reltoastidxid;
  
  	appendPQExpBuffer(upgrade_query,
! 					  "SELECT c.reltoastrelid, t.reltoastidxid "
  					  "FROM pg_catalog.pg_class c LEFT JOIN "
! 					  "pg_catalog.pg_class t ON (c.reltoastrelid = t.oid) "
! 					  "WHERE c.oid = '%u'::pg_catalog.oid;",
  					  pg_class_oid);
  
  	upgrade_res = ExecuteSqlQueryForSingleRow(fout, upgrade_query->data);
  
  	pg_class_reltoastrelid = atooid(PQgetvalue(upgrade_res, 0, PQfnumber(upgrade_res, "reltoastrelid")));
! 	pg_class_reltoastidxid = atooid(PQgetvalue(upgrade_res, 0, PQfnumber(upgrade_res, "reltoastidxid")));
  
  	appendPQExpBuffer(upgrade_buffer,
  				   "\n-- For binary upgrade, must preserve pg_class oids\n");
--- 2781,2796 ----
  	Oid			pg_class_reltoastidxid;
  
  	appendPQExpBuffer(upgrade_query,
! 					  "SELECT c.reltoastrelid, t.indexrelid "
  					  "FROM pg_catalog.pg_class c LEFT JOIN "
! 					  "pg_catalog.pg_index t ON (c.reltoastrelid = t.indrelid) "
! 					  "WHERE c.oid = '%u'::pg_catalog.oid AND t.indisvalid;",
  					  pg_class_oid);
  
  	upgrade_res = ExecuteSqlQueryForSingleRow(fout, upgrade_query->data);
  
  	pg_class_reltoastrelid = atooid(PQgetvalue(upgrade_res, 0, PQfnumber(upgrade_res, "reltoastrelid")));
! 	pg_class_reltoastidxid = atooid(PQgetvalue(upgrade_res, 0, PQfnumber(upgrade_res, "indexrelid")));
  
  	appendPQExpBuffer(upgrade_buffer,
  				   "\n-- For binary upgrade, must preserve pg_class oids\n");
***************
*** 2816,2822 **** binary_upgrade_set_pg_class_oids(Archive *fout,
  							  "SELECT binary_upgrade.set_next_toast_pg_class_oid('%u'::pg_catalog.oid);\n",
  							  pg_class_reltoastrelid);
  
! 			/* every toast table has an index */
  			appendPQExpBuffer(upgrade_buffer,
  							  "SELECT binary_upgrade.set_next_index_pg_class_oid('%u'::pg_catalog.oid);\n",
  							  pg_class_reltoastidxid);
--- 2816,2822 ----
  							  "SELECT binary_upgrade.set_next_toast_pg_class_oid('%u'::pg_catalog.oid);\n",
  							  pg_class_reltoastrelid);
  
! 			/* every toast table has one valid index */
  			appendPQExpBuffer(upgrade_buffer,
  							  "SELECT binary_upgrade.set_next_index_pg_class_oid('%u'::pg_catalog.oid);\n",
  							  pg_class_reltoastidxid);
*** a/src/include/access/tuptoaster.h
--- b/src/include/access/tuptoaster.h
***************
*** 15,20 ****
--- 15,21 ----
  
  #include "access/htup_details.h"
  #include "utils/relcache.h"
+ #include "storage/lock.h"
  
  /*
   * This enables de-toasting of index entries.  Needed until VACUUM is
***************
*** 188,191 **** extern Size toast_raw_datum_size(Datum value);
--- 189,200 ----
   */
  extern Size toast_datum_size(Datum value);
  
+ /* ----------
+  * toast_get_valid_index -
+  *
+  *	Return valid index associated to a toast relation
+  * ----------
+  */
+ extern Oid toast_get_valid_index(Oid toastoid, LOCKMODE lock);
+ 
  #endif   /* TUPTOASTER_H */
*** a/src/include/catalog/pg_class.h
--- b/src/include/catalog/pg_class.h
***************
*** 48,54 **** CATALOG(pg_class,1259) BKI_BOOTSTRAP BKI_ROWTYPE_OID(83) BKI_SCHEMA_MACRO
  	int32		relallvisible;	/* # of all-visible blocks (not always
  								 * up-to-date) */
  	Oid			reltoastrelid;	/* OID of toast table; 0 if none */
- 	Oid			reltoastidxid;	/* if toast table, OID of chunk_id index */
  	bool		relhasindex;	/* T if has (or has had) any indexes */
  	bool		relisshared;	/* T if shared across databases */
  	char		relpersistence; /* see RELPERSISTENCE_xxx constants below */
--- 48,53 ----
*** a/src/test/regress/expected/oidjoins.out
--- b/src/test/regress/expected/oidjoins.out
***************
*** 353,366 **** WHERE	reltoastrelid != 0 AND
  ------+---------------
  (0 rows)
  
- SELECT	ctid, reltoastidxid
- FROM	pg_catalog.pg_class fk
- WHERE	reltoastidxid != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_class pk WHERE pk.oid = fk.reltoastidxid);
-  ctid | reltoastidxid 
- ------+---------------
- (0 rows)
- 
  SELECT	ctid, collnamespace
  FROM	pg_catalog.pg_collation fk
  WHERE	collnamespace != 0 AND
--- 353,358 ----
*** a/src/test/regress/expected/rules.out
--- b/src/test/regress/expected/rules.out
***************
*** 1852,1866 **** SELECT viewname, definition FROM pg_views WHERE schemaname <> 'information_schem
                                   |     (sum(pg_stat_get_blocks_hit(i.indexrelid)))::bigint AS idx_blks_hit,                                                                                                                                       +
                                   |     (pg_stat_get_blocks_fetched(t.oid) - pg_stat_get_blocks_hit(t.oid)) AS toast_blks_read,                                                                                                                    +
                                   |     pg_stat_get_blocks_hit(t.oid) AS toast_blks_hit,                                                                                                                                                           +
!                                  |     (pg_stat_get_blocks_fetched(x.oid) - pg_stat_get_blocks_hit(x.oid)) AS tidx_blks_read,                                                                                                                     +
!                                  |     pg_stat_get_blocks_hit(x.oid) AS tidx_blks_hit                                                                                                                                                             +
                                   |    FROM ((((pg_class c                                                                                                                                                                                         +
                                   |    LEFT JOIN pg_index i ON ((c.oid = i.indrelid)))                                                                                                                                                             +
                                   |    LEFT JOIN pg_class t ON ((c.reltoastrelid = t.oid)))                                                                                                                                                        +
!                                  |    LEFT JOIN pg_class x ON ((t.reltoastidxid = x.oid)))                                                                                                                                                        +
                                   |    LEFT JOIN pg_namespace n ON ((n.oid = c.relnamespace)))                                                                                                                                                     +
                                   |   WHERE (c.relkind = ANY (ARRAY['r'::"char", 't'::"char", 'm'::"char"]))                                                                                                                                       +
!                                  |   GROUP BY c.oid, n.nspname, c.relname, t.oid, x.oid;
   pg_statio_sys_indexes           |  SELECT pg_statio_all_indexes.relid,                                                                                                                                                                           +
                                   |     pg_statio_all_indexes.indexrelid,                                                                                                                                                                          +
                                   |     pg_statio_all_indexes.schemaname,                                                                                                                                                                          +
--- 1852,1866 ----
                                   |     (sum(pg_stat_get_blocks_hit(i.indexrelid)))::bigint AS idx_blks_hit,                                                                                                                                       +
                                   |     (pg_stat_get_blocks_fetched(t.oid) - pg_stat_get_blocks_hit(t.oid)) AS toast_blks_read,                                                                                                                    +
                                   |     pg_stat_get_blocks_hit(t.oid) AS toast_blks_hit,                                                                                                                                                           +
!                                  |     (sum((pg_stat_get_blocks_fetched(x.indexrelid) - pg_stat_get_blocks_hit(x.indexrelid))))::bigint AS tidx_blks_read,                                                                                        +
!                                  |     (sum(pg_stat_get_blocks_hit(x.indexrelid)))::bigint AS tidx_blks_hit                                                                                                                                       +
                                   |    FROM ((((pg_class c                                                                                                                                                                                         +
                                   |    LEFT JOIN pg_index i ON ((c.oid = i.indrelid)))                                                                                                                                                             +
                                   |    LEFT JOIN pg_class t ON ((c.reltoastrelid = t.oid)))                                                                                                                                                        +
!                                  |    LEFT JOIN pg_index x ON ((t.oid = x.indrelid)))                                                                                                                                                             +
                                   |    LEFT JOIN pg_namespace n ON ((n.oid = c.relnamespace)))                                                                                                                                                     +
                                   |   WHERE (c.relkind = ANY (ARRAY['r'::"char", 't'::"char", 'm'::"char"]))                                                                                                                                       +
!                                  |   GROUP BY c.oid, n.nspname, c.relname, t.oid, x.indexrelid;
   pg_statio_sys_indexes           |  SELECT pg_statio_all_indexes.relid,                                                                                                                                                                           +
                                   |     pg_statio_all_indexes.indexrelid,                                                                                                                                                                          +
                                   |     pg_statio_all_indexes.schemaname,                                                                                                                                                                          +
***************
*** 2347,2357 **** select xmin, * from fooview;  -- fail, views don't have such a column
  ERROR:  column "xmin" does not exist
  LINE 1: select xmin, * from fooview;
                 ^
! select reltoastrelid, reltoastidxid, relkind, relfrozenxid
    from pg_class where oid = 'fooview'::regclass;
!  reltoastrelid | reltoastidxid | relkind | relfrozenxid 
! ---------------+---------------+---------+--------------
!              0 |             0 | v       |            0
  (1 row)
  
  drop view fooview;
--- 2347,2357 ----
  ERROR:  column "xmin" does not exist
  LINE 1: select xmin, * from fooview;
                 ^
! select reltoastrelid, relkind, relfrozenxid
    from pg_class where oid = 'fooview'::regclass;
!  reltoastrelid | relkind | relfrozenxid 
! ---------------+---------+--------------
!              0 | v       |            0
  (1 row)
  
  drop view fooview;
*** a/src/test/regress/sql/oidjoins.sql
--- b/src/test/regress/sql/oidjoins.sql
***************
*** 177,186 **** SELECT	ctid, reltoastrelid
  FROM	pg_catalog.pg_class fk
  WHERE	reltoastrelid != 0 AND
  	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_class pk WHERE pk.oid = fk.reltoastrelid);
- SELECT	ctid, reltoastidxid
- FROM	pg_catalog.pg_class fk
- WHERE	reltoastidxid != 0 AND
- 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_class pk WHERE pk.oid = fk.reltoastidxid);
  SELECT	ctid, collnamespace
  FROM	pg_catalog.pg_collation fk
  WHERE	collnamespace != 0 AND
--- 177,182 ----
*** a/src/test/regress/sql/rules.sql
--- b/src/test/regress/sql/rules.sql
***************
*** 872,878 **** create rule "_RETURN" as on select to fooview do instead
  select * from fooview;
  select xmin, * from fooview;  -- fail, views don't have such a column
  
! select reltoastrelid, reltoastidxid, relkind, relfrozenxid
    from pg_class where oid = 'fooview'::regclass;
  
  drop view fooview;
--- 872,878 ----
  select * from fooview;
  select xmin, * from fooview;  -- fail, views don't have such a column
  
! select reltoastrelid, relkind, relfrozenxid
    from pg_class where oid = 'fooview'::regclass;
  
  drop view fooview;
*** a/src/tools/findoidjoins/README
--- b/src/tools/findoidjoins/README
***************
*** 86,92 **** Join pg_catalog.pg_class.relowner => pg_catalog.pg_authid.oid
  Join pg_catalog.pg_class.relam => pg_catalog.pg_am.oid
  Join pg_catalog.pg_class.reltablespace => pg_catalog.pg_tablespace.oid
  Join pg_catalog.pg_class.reltoastrelid => pg_catalog.pg_class.oid
- Join pg_catalog.pg_class.reltoastidxid => pg_catalog.pg_class.oid
  Join pg_catalog.pg_collation.collnamespace => pg_catalog.pg_namespace.oid
  Join pg_catalog.pg_collation.collowner => pg_catalog.pg_authid.oid
  Join pg_catalog.pg_constraint.connamespace => pg_catalog.pg_namespace.oid
--- 86,91 ----
